' SQLITE demo
' by Jef Rozenski JAN 2004
'
' Updated to embed sqlite3 with PellesC by Andreas Haensch October 2005
'
' Needs a subfolder include/ with SQLite32Lib.LIB and sqlite3.h
' No need for sqlite3.dll
' See http://www.sqlite.org/
' see also listview gui demos

$COMPILER "pocc.exe -Tx86-coff /W1 /Os /Gd /Ze /Zx"
$LINKER   "polink.exe /LIBPATH:C:\BCX\SQLite\SQLite3_win-embedded\include -subsystem:windows -machine:ix86  kernel32.lib advapi32.lib delayimp.lib SQLite32Lib.lib -out:sqlite_3.exe sqlite_3.obj"
#Include "include/sqlite3.h"

GUI "SQLITE_BASE"

CONST quote$ = CHR$(34)
DIM Form1   AS HWND
DIM Button1 AS HWND
DIM Button2 AS HWND
DIM Button3 AS HWND
DIM Combo1  AS HWND
DIM Listv1  AS HWND
DIM astring$
DIM rc AS LONG
DIM dbHandle AS sqlite3 PTR
DIM CURRENTPOS

SUB FORMLOAD
DIM RAW iret%
Form1   = BCX_FORM("SQLITE_BASE",0,0,300,120)
Button1 = BCX_BUTTON("Create"     ,Form1,101,5,20,50,12)
Button2 = BCX_BUTTON("SQLite version",Form1,102,5,40,50,12)
Button3 = BCX_BUTTON("Exec SQL"   ,Form1,103,5,80,50,12)
Combo1  = BCX_COMBOBOX(""         ,Form1,104,5,60,120,100)
Listv1  = BCX_CONTROL(WC_LISTVIEW, Form1, "", 110, 135, 5, 155, 100, _
  WS_CHILD | WS_VISIBLE | WS_TABSTOP | LVS_REPORT | LVS_SINGLESEL | LVS_SHOWSELALWAYS, WS_EX_CLIENTEDGE)
ModListView(Listv1)
ModCombo(Combo1)
'dbHandle = sqlite_open(LIB "sqlite.dll","demo.db",0,NULL)   ' open a database (Version2.x dll)
'iret% = sqlite3_open(LIB "sqlite3.dll","demo.db",&dbHandle) ' open a database (Version3.x dll)
iret% = sqlite3_open("demo.db",&dbHandle)  ' open a database (Version3.x embedded)
IF iret% <> 0 THEN 'SQLITE_OK = 0
   msgbox "Opening <demo.db> failed!", JOIN$(2, APPEXENAME$, "will terminate now."), MB_OK|MB_ICONERROR
   END
END IF
CENTER(Form1)
SHOW(Form1)
END SUB

BEGIN EVENTS
SELECT CASE CBMSG
'----------------
  CASE WM_COMMAND
'----------------
  IF CBCTL = 101 THEN  
    astring$ = "CREATE TABLE test (item varchar primary key, color text, price real);"
    rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
    astring$ = "DBcreation rc: " & STR$(rc)
    MSGBOX astring$
    IF rc = 0 THEN       ' add some data (only the first time)
      astring$ = "INSERT INTO test VALUES ('apple1','green',0.95);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('apple2','red',0.85);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('tomato','red',0.65);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('strawberry','red',0.75);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('banana','yellow',1.25);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('pineapple','yellow',1.95);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('beans1','green',0.35);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
      astring$ = "INSERT INTO test VALUES ('beans2','yellow',0.40);"
      rc = sqlite3_exec(dbHandle,astring$,NULL,NULL,NULL)
    END IF
    astring$ = "SELECT * FROM test"
    ExecSQL(astring$)
  END IF
  IF CBCTL = 102 THEN  
   astring$ = sqlite3_libversion()
   MSGBOX "SQLite version: " & astring$
  END IF
  IF CBCTL = 103 THEN
    rc = SendMessage(Combo1,CB_GETCURSEL,0,0)
    IF rc >= 0 THEN
      SendMessage(Combo1,CB_GETLBTEXT,rc,(LPCSTR) astring$)
    ELSE
      astring$ = ""
    END IF
    ExecSQL(astring$)
  END IF
  EXIT FUNCTION
'--------------
  CASE WM_CLOSE
'--------------
  sqlite3_close(dbHandle)   ' close the database
  DestroyWindow (Form1)
  EXIT FUNCTION
'--------------
CASE WM_DESTROY
'--------------
  PostQuitMessage(0)
  EXIT FUNCTION
END SELECT
END EVENTS

SUB ModListView(hWnd AS HWND)
LOCAL lvStyle
GLOBAL lvCol AS LV_COLUMN
SendMessage(hWnd, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT),0)
lvStyle = LVS_EX_GRIDLINES OR LVS_EX_FULLROWSELECT
SendMessage(hWnd,LVM_SETEXTENDEDLISTVIEWSTYLE, 0, lvStyle)
lvCol.mask      =  LVCF_FMT OR LVCF_WIDTH OR LVCF_TEXT OR LVCF_SUBITEM
lvCol.fmt       =  LVCFMT_LEFT
lvCol.cx        =  100
lvCol.pszText   =  "item"
lvCol.iSubItem  =   0
ListView_InsertColumn(hWnd, 0, &lvCol)
lvCol.cx        =  100
lvCol.pszText   = "color"
lvCol.iSubItem  =  1
ListView_InsertColumn(hWnd, 1, &lvCol)
lvCol.cx        =  100
lvCol.pszText   = "price"
lvCol.iSubItem  =  2
ListView_InsertColumn(hWnd, 2, &lvCol)
END SUB

SUB ModCombo(hWnd AS HWND)                            ' some predefined SQL statements
astring$ = "SELECT * FROM test ORDER BY PRICE;"
SendMessage(hWnd,CB_ADDSTRING,0,astring$)
astring$ = "SELECT * FROM test WHERE color = 'red';"
SendMessage(hWnd,CB_ADDSTRING,0,astring$)
astring$ = "SELECT * FROM test WHERE item LIKE 'b%'"
SendMessage(hWnd,CB_ADDSTRING,0,astring$)
END SUB

FUNCTION MyCallback(lpv AS LPVOID,cols AS INT,lpdata[] AS LPSTR,colnames[] AS LPSTR) AS INTEGER
'
' this function is executed for each hit from an sqlite_exec call
'
DIM lvItem AS LV_ITEM
LOCAL i
lvItem.mask       =  LVIF_TEXT    ' sqlite data is stored as text
lvItem.iItem      =  CURRENTPOS   ' position where to insert
ListView_InsertItem(Listv1,&lvItem)
FOR i = 0 TO cols-1
  ListView_SetItemText(Listv1,CURRENTPOS,i,lpdata[i])  ' put text in listview
NEXT
INCR(CURRENTPOS)
FUNCTION = 0
END FUNCTION

FUNCTION ExecSQL(SQLstring$) as INTEGER                ' execute SQL command
ListView_DeleteAllItems(Listv1)                        ' first clear listview
CURRENTPOS = 0                                         ' current insert position for listview
FUNCTION = sqlite3_exec(dbHandle,SQLstring$,MyCallback,NULL,NULL)
END FUNCTION